Index: src/Fragmentation/Summation/SetValues/SamplingGrid.cpp
===================================================================
--- src/Fragmentation/Summation/SetValues/SamplingGrid.cpp	(revision c6ddcb49851617a614ac989bfeae41c91886a779)
+++ src/Fragmentation/Summation/SetValues/SamplingGrid.cpp	(revision 0287906894892db049741ca98305c9ab54844136)
@@ -272,43 +272,4 @@
     return 0.;
 }
-
-double SamplingGrid::getNearestLowerGridPoint(
-    const double value, const size_t axis) const
-{
-  const double length = getTotalLengthPerAxis(axis);
-  if ((fabs(length) < std::numeric_limits<double>::epsilon()) || (getGridPointsPerAxis() == 0))
-    return begin[axis];
-  if ((value - end[axis]) > -std::numeric_limits<double>::epsilon()*1.e4)
-    return end[axis];
-  const double offset = value - begin[axis];
-  if (offset < std::numeric_limits<double>::epsilon()*1.e4)
-    return begin[axis];
-  // modify value a little if value actually has been on a grid point but
-  // perturbed by numerical rounding: here up, as we always go lower
-  const double factor =
-      floor((double)getGridPointsPerAxis()*(offset/length)
-          +std::numeric_limits<double>::epsilon()*1.e4);
-  return begin[axis]+factor*getDeltaPerAxis(axis);
-}
-
-double SamplingGrid::getNearestHigherGridPoint(
-    const double value, const size_t axis) const
-{
-  const double length = getTotalLengthPerAxis(axis);
-  if ((fabs(length) < std::numeric_limits<double>::epsilon()) || (getGridPointsPerAxis() == 0))
-    return end[axis];
-  if ((value - end[axis]) > -std::numeric_limits<double>::epsilon()*1.e4)
-    return end[axis];
-  const double offset = value - begin[axis];
-  if (offset < std::numeric_limits<double>::epsilon()*1.e4)
-    return begin[axis];
-  // modify value a little if value actually has been on a grid point but
-  // perturbed by numerical rounding: here down, as we always go higher
-  const double factor =
-      ceil((double)getGridPointsPerAxis()*(offset/length)
-          -std::numeric_limits<double>::epsilon()*1.e4);
-  return begin[axis]+factor*getDeltaPerAxis(axis);
-}
-
 void SamplingGrid::setWindowSize(
     const double _begin_window[3],
Index: src/Fragmentation/Summation/SetValues/SamplingGrid.hpp
===================================================================
--- src/Fragmentation/Summation/SetValues/SamplingGrid.hpp	(revision c6ddcb49851617a614ac989bfeae41c91886a779)
+++ src/Fragmentation/Summation/SetValues/SamplingGrid.hpp	(revision 0287906894892db049741ca98305c9ab54844136)
@@ -362,22 +362,4 @@
   void setWindowSize(const double _begin_window[3], const double _end_window[3]);
 
-  /** Helper function to get point at grid point for given \a axis and less than value.
-   *
-   * @param value value to find nearest grid point to
-   * @param axis axis of the value
-   * @return nearest lower grid point
-   */
-  double getNearestLowerGridPoint(
-      const double value, const size_t axis) const;
-
-  /** Helper function to get point at grid point for given \a axis and greater than value.
-   *
-   * @param value value to find nearest grid point to
-   * @param axis axis of the value
-   * @return nearest lower grid point
-   */
-  double getNearestHigherGridPoint(
-      const double value, const size_t axis) const;
-
 public:
   /// We do not store the whole grid if many entries are actually zero
Index: src/Fragmentation/Summation/SetValues/SamplingGridProperties.cpp
===================================================================
--- src/Fragmentation/Summation/SetValues/SamplingGridProperties.cpp	(revision c6ddcb49851617a614ac989bfeae41c91886a779)
+++ src/Fragmentation/Summation/SetValues/SamplingGridProperties.cpp	(revision 0287906894892db049741ca98305c9ab54844136)
@@ -101,4 +101,43 @@
 
 
+double SamplingGridProperties::getNearestLowerGridPoint(
+    const double value, const size_t axis) const
+{
+  const double length = getTotalLengthPerAxis(axis);
+  if ((fabs(length) < std::numeric_limits<double>::epsilon()) || (getGridPointsPerAxis() == 0))
+    return begin[axis];
+  if ((value - end[axis]) > -std::numeric_limits<double>::epsilon()*1.e4)
+    return end[axis];
+  const double offset = value - begin[axis];
+  if (offset < std::numeric_limits<double>::epsilon()*1.e4)
+    return begin[axis];
+  // modify value a little if value actually has been on a grid point but
+  // perturbed by numerical rounding: here up, as we always go lower
+  const double factor =
+      floor((double)getGridPointsPerAxis()*(offset/length)
+          +std::numeric_limits<double>::epsilon()*1.e4);
+  return begin[axis]+factor*getDeltaPerAxis(axis);
+}
+
+double SamplingGridProperties::getNearestHigherGridPoint(
+    const double value, const size_t axis) const
+{
+  const double length = getTotalLengthPerAxis(axis);
+  if ((fabs(length) < std::numeric_limits<double>::epsilon()) || (getGridPointsPerAxis() == 0))
+    return end[axis];
+  if ((value - end[axis]) > -std::numeric_limits<double>::epsilon()*1.e4)
+    return end[axis];
+  const double offset = value - begin[axis];
+  if (offset < std::numeric_limits<double>::epsilon()*1.e4)
+    return begin[axis];
+  // modify value a little if value actually has been on a grid point but
+  // perturbed by numerical rounding: here down, as we always go higher
+  const double factor =
+      ceil((double)getGridPointsPerAxis()*(offset/length)
+          -std::numeric_limits<double>::epsilon()*1.e4);
+  return begin[axis]+factor*getDeltaPerAxis(axis);
+}
+
+
 template<> SamplingGridProperties ZeroInstance<SamplingGridProperties>()
 {
Index: src/Fragmentation/Summation/SetValues/SamplingGridProperties.hpp
===================================================================
--- src/Fragmentation/Summation/SetValues/SamplingGridProperties.hpp	(revision c6ddcb49851617a614ac989bfeae41c91886a779)
+++ src/Fragmentation/Summation/SetValues/SamplingGridProperties.hpp	(revision 0287906894892db049741ca98305c9ab54844136)
@@ -112,4 +112,21 @@
   const double getDeltaPerAxis(const size_t axis) const;
 
+  /** Helper function to get point at grid point for given \a axis and less than value.
+   *
+   * @param value value to find nearest grid point to
+   * @param axis axis of the value
+   * @return nearest lower grid point
+   */
+  double getNearestLowerGridPoint(
+      const double value, const size_t axis) const;
+
+  /** Helper function to get point at grid point for given \a axis and greater than value.
+   *
+   * @param value value to find nearest grid point to
+   * @param axis axis of the value
+   * @return nearest lower grid point
+   */
+  double getNearestHigherGridPoint(
+      const double value, const size_t axis) const;
 
 public: