Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Actions/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -543,7 +543,7 @@
 libMolecuilderActionPrototypes_la_CPPFLAGS += $(JobMarket_CFLAGS)
 endif
-libMolecuilderActions_la_includedir = $(includedir)/MoleCuilder/Actions/
-libMolecuilderActionPrototypes_la_includedir = $(includedir)/MoleCuilder/Actions/
-#libMolecuilderActionPython_la_includedir = $(includedir)/MoleCuilder/Actions/
+libMolecuilderActions_la_includedir = $(includedir)/MoleCuilder/
+libMolecuilderActionPrototypes_la_includedir = $(includedir)/MoleCuilder/
+#libMolecuilderActionPython_la_includedir = $(includedir)/MoleCuilder/
 
 BUILT_SOURCES += AllActionHeaders.hpp
Index: src/Analysis/Makefile.am
===================================================================
--- src/Analysis/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Analysis/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -12,5 +12,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderAnalysis.la
-libMolecuilderAnalysis_la_includedir = $(includedir)/MoleCuilder/Analysis/
+libMolecuilderAnalysis_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderAnalysis_la_include_HEADERS = ${ANALYSISHEADER}
Index: src/Atom/Makefile.am
===================================================================
--- src/Atom/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Atom/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -40,5 +40,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderAtom.la
-libMolecuilderAtom_la_includedir = $(includedir)/MoleCuilder/Atom/
+libMolecuilderAtom_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderAtom_la_include_HEADERS = $(ATOMHEADER) $(COPYATOMSHEADER) 
Index: src/Element/Makefile.am
===================================================================
--- src/Element/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Element/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -14,5 +14,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderElement.la
-libMolecuilderElement_la_includedir = $(includedir)/MoleCuilder/Element/
+libMolecuilderElement_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderElement_la_include_HEADERS = ${ELEMENTHEADER}
Index: src/Filling/Makefile.am
===================================================================
--- src/Filling/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Filling/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -48,5 +48,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFilling.la
-libMolecuilderFilling_la_includedir = $(includedir)/MoleCuilder/Filling/
+libMolecuilderFilling_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderFilling_la_include_HEADERS = ${FILLINGHEADER}
Index: src/Fragmentation/Automation/Makefile.am
===================================================================
--- src/Fragmentation/Automation/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Automation/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -26,5 +26,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFragmentationAutomation.la
-libMolecuilderFragmentationAutomation_la_includedir = $(includedir)/MoleCuilder/Fragmentation/Automation/
+libMolecuilderFragmentationAutomation_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentationAutomation_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS} $(JobMarket_CFLAGS)
 libMolecuilderFragmentationAutomation_la_LDFLAGS = -ldl ${BOOST_LDFLAGS}
Index: src/Fragmentation/Makefile.am
===================================================================
--- src/Fragmentation/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -69,8 +69,8 @@
 	libMolecuilderFragmentation_getFromKeyset.la \
 	libMolecuilderFragmentation_getFromKeysetStub.la
-libMolecuilderFragmentation_la_includedir = $(includedir)/MoleCuilder/Fragmentation/
-libMolecuilderFragmentation_KeysetsContainer_la_includedir = $(includedir)/MoleCuilder/Fragmentation/
-libMolecuilderFragmentation_getFromKeyset_la_includedir = $(includedir)/MoleCuilder/Fragmentation/
-libMolecuilderFragmentation_getFromKeysetStub_la_includedir = $(includedir)/MoleCuilder/Fragmentation/
+libMolecuilderFragmentation_la_includedir = $(includedir)/MoleCuilder/
+libMolecuilderFragmentation_KeysetsContainer_la_includedir = $(includedir)/MoleCuilder/
+libMolecuilderFragmentation_getFromKeyset_la_includedir = $(includedir)/MoleCuilder/
+libMolecuilderFragmentation_getFromKeysetStub_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentation_la_CPPFLAGS = $(AM_CPPFLAGS)
 libMolecuilderFragmentation_la_LDFLAGS = $(AM_LDFLAGS)
Index: src/Fragmentation/Summation/Containers/Makefile.am
===================================================================
--- src/Fragmentation/Summation/Containers/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Summation/Containers/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -36,5 +36,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFragmentationContainers.la
-libMolecuilderFragmentationContainers_la_includedir = $(includedir)/MoleCuilder/Fragmentation/Summation/Containers/
+libMolecuilderFragmentationContainers_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentationContainers_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS} $(JobMarket_CFLAGS)
 libMolecuilderFragmentationContainers_la_LDFLAGS = -ldl ${BOOST_LDFLAGS}
Index: src/Fragmentation/Summation/Converter/Makefile.am
===================================================================
--- src/Fragmentation/Summation/Converter/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Summation/Converter/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -9,5 +9,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFragmentationConverter.la
-libMolecuilderFragmentationConverter_la_includedir = $(includedir)/MoleCuilder/Fragmentation/Summation/Converter/
+libMolecuilderFragmentationConverter_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentationConverter_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS}
 libMolecuilderFragmentationConverter_la_LDFLAGS = -ldl ${BOOST_LDFLAGS}
Index: src/Fragmentation/Summation/Makefile.am
===================================================================
--- src/Fragmentation/Summation/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Summation/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -32,5 +32,5 @@
 
 lib_LTLIBRARIES += libMolecuilderFragmentationSummation.la
-libMolecuilderFragmentationSummation_la_includedir = $(includedir)/MoleCuilder/Fragmentation/Summation/
+libMolecuilderFragmentationSummation_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentationSummation_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS}
 libMolecuilderFragmentationSummation_la_LDFLAGS = -ldl ${BOOST_LDFLAGS}
Index: src/Fragmentation/Summation/SetValues/Makefile.am
===================================================================
--- src/Fragmentation/Summation/SetValues/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Fragmentation/Summation/SetValues/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -20,5 +20,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFragmentationSetValues.la
-libMolecuilderFragmentationSetValues_la_includedir = $(includedir)/MoleCuilder/Fragmentation/Summation/SetValues/
+libMolecuilderFragmentationSetValues_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFragmentationSetValues_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS}
 libMolecuilderFragmentationSetValues_la_LDFLAGS = -ldl ${BOOST_LDFLAGS}
Index: src/FunctionApproximation/Makefile.am
===================================================================
--- src/FunctionApproximation/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/FunctionApproximation/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -22,5 +22,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderFunctionApproximation.la
-libMolecuilderFunctionApproximation_la_includedir = $(includedir)/MoleCuilder/FunctionApproximation/
+libMolecuilderFunctionApproximation_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderFunctionApproximation_la_CPPFLAGS = $(AM_CPPFLAGS)
 libMolecuilderFunctionApproximation_la_LDFLAGS = $(AM_LDFLAGS)
Index: src/Graph/Makefile.am
===================================================================
--- src/Graph/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Graph/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -23,5 +23,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderGraph.la
-libMolecuilderGraph_la_includedir = $(includedir)/MoleCuilder/Graph/
+libMolecuilderGraph_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderGraph_la_include_HEADERS = ${GRAPHHEADER}
Index: src/Helpers/Makefile.am
===================================================================
--- src/Helpers/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Helpers/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -12,5 +12,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderHelpers.la
-libMolecuilderHelpers_la_includedir = $(includedir)/MoleCuilder/Helpers/
+libMolecuilderHelpers_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderHelpers_la_include_HEADERS = ${HELPERSHEADER}
Index: src/LinkedCell/Makefile.am
===================================================================
--- src/LinkedCell/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/LinkedCell/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -31,5 +31,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderLinkedCell.la
-libMolecuilderLinkedCell_la_includedir = $(includedir)/MoleCuilder/LinkedCell/
+libMolecuilderLinkedCell_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderLinkedCell_la_include_HEADERS = ${LINKEDCELLHEADER}
Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Parameters/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -77,5 +77,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderParameters.la
-libMolecuilderParameters_la_includedir = $(includedir)/MoleCuilder/Parameters/
+libMolecuilderParameters_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderParameters_la_include_HEADERS = ${PARAMETERHEADER}
Index: src/Parser/Makefile.am
===================================================================
--- src/Parser/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Parser/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -84,5 +84,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderParser.la
-libMolecuilderParser_la_includedir = $(includedir)/MoleCuilder/Parser/
+libMolecuilderParser_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderParser_la_include_HEADERS = ${PARSERHEADER} ${PARSERPARAMETERSHEADER} $(PUGIXMLHEADER)
Index: src/Potentials/Makefile.am
===================================================================
--- src/Potentials/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Potentials/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -29,5 +29,5 @@
 
 noinst_LTLIBRARIES += libMolecuilderPotentials.la
-libMolecuilderPotentials_la_includedir = $(includedir)/MoleCuilder/Potentials/
+libMolecuilderPotentials_la_includedir = $(includedir)/MoleCuilder/
 
 nobase_libMolecuilderPotentials_la_include_HEADERS = ${POTENTIALSHEADER}
Index: src/RandomNumbers/Makefile.am
===================================================================
--- src/RandomNumbers/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/RandomNumbers/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -42,5 +42,5 @@
 
 lib_LTLIBRARIES += libMolecuilderRandomNumbers.la
-libMolecuilderRandomNumbers_includedir = $(includedir)/MoleCuilder/RandomNumbers/
+libMolecuilderRandomNumbers_includedir = $(includedir)/MoleCuilder/
 nobase_libMolecuilderRandomNumbers_include_HEADERS = ${RANDOMHEADER} ${RANDOMDEFS}
 
Index: src/Shapes/Makefile.am
===================================================================
--- src/Shapes/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/Shapes/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -22,5 +22,5 @@
 
 lib_LTLIBRARIES += libMolecuilderShapes.la
-libMolecuilderShapes_la_includedir = $(includedir)/MoleCuilder/Shapes/
+libMolecuilderShapes_la_includedir = $(includedir)/MoleCuilder/
 nobase_libMolecuilderShapes_la_include_HEADERS = ${SHAPEHEADER}
 
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision a3fc46e1ebd9065c243c909e5fef221d7add4620)
+++ src/UIElements/Makefile.am	(revision 214240311376bc0a14571b81249ac930343e5a7b)
@@ -212,5 +212,5 @@
 
 lib_LTLIBRARIES += libMolecuilderUI.la
-libMolecuilderUI_la_includedir = $(includedir)/MoleCuilder/UIElements/
+libMolecuilderUI_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderUI_la_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS} 
 if CONDJOBMARKET
@@ -306,5 +306,5 @@
 lib_LTLIBRARIES += libMolecuilderQtUI.la
 
-libMolecuilderQtUI_la_includedir = $(includedir)/MoleCuilder/UIElements/
+libMolecuilderQtUI_la_includedir = $(includedir)/MoleCuilder/
 libMolecuilderQtUI_la_CPPFLAGS = ${QT_CFLAGS} ${GLU_CXXFLAGS} ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS}  ${JobMarket_CFLAGS}
 libMolecuilderQtUI_la_LDFLAGS = $(AM_LDFLAGS) $(BOOST_FILESYSTEM_LDFLAGS) $(BOOST_PROGRAM_OPTIONS_LDFLAGS) $(BOOST_RANDOM_LDFLAGS) $(BOOST_SYSTEM_LDFLAGS) $(BOOST_THREAD_LDFLAGS)