Index: src/Actions/MoleculeAction/ForceAnnealingAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ForceAnnealingAction.cpp	(revision b2acca5104402761508b07b19e72cf9e4706bced)
+++ src/Actions/MoleculeAction/ForceAnnealingAction.cpp	(revision 21684049418b92d984cca9a3de2814706b588f5f)
@@ -113,4 +113,5 @@
   ForceAnnealing<std::vector<atom *> > optimizer(
       set,
+      params.deltat.get(),
       true,
       params.steps.get(),
Index: src/Actions/MoleculeAction/ForceAnnealingAction.def
===================================================================
--- src/Actions/MoleculeAction/ForceAnnealingAction.def	(revision b2acca5104402761508b07b19e72cf9e4706bced)
+++ src/Actions/MoleculeAction/ForceAnnealingAction.def	(revision 21684049418b92d984cca9a3de2814706b588f5f)
@@ -9,4 +9,6 @@
 #include <boost/filesystem/path.hpp>
 
+#include <limits>
+
 #include "Parameters/Validators/DummyValidator.hpp"
 #include "Parameters/Validators/GenericValidators.hpp"
@@ -17,11 +19,12 @@
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
 // "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
-#define paramtypes (boost::filesystem::path)(unsigned int)(bool)(int)(double)(bool)
-#define paramtokens ("forces-file")("steps")("output-every-step")("max-distance")("damping-factor")("use-bondgraph")
-#define paramdescriptions ("file containing")("fixed number of optimization steps to be performed")("whether WorldTime should be increased and output written after every step, useful if optimization might hang")("maximum distance to which bond graph is taken into account")("damping factor for decreasing the shift with bond graph distance from the causing site")("whether annealing should take place focusing on atoms alone or on the bonds (faster)")
-#define paramdefaults (PARAM_DEFAULT(""))(NOPARAM_DEFAULT)(PARAM_DEFAULT("0"))(PARAM_DEFAULT(0))(PARAM_DEFAULT(0.5))(PARAM_DEFAULT(0))
-#define paramreferences (forcesfile)(steps)(DoOutput)(MaxDistance)(DampingFactor)(UseBondGraph)
+#define paramtypes (boost::filesystem::path)(double)(unsigned int)(bool)(int)(double)(bool)
+#define paramtokens ("forces-file")("deltat")("steps")("output-every-step")("max-distance")("damping-factor")("use-bondgraph")
+#define paramdescriptions ("file containing")("basic step width to be used")("fixed number of optimization steps to be performed")("whether WorldTime should be increased and output written after every step, useful if optimization might hang")("maximum distance to which bond graph is taken into account")("damping factor for decreasing the shift with bond graph distance from the causing site")("whether annealing should take place focusing on atoms alone or on the bonds (faster)")
+#define paramdefaults (PARAM_DEFAULT(""))(PARAM_DEFAULT(0.1))(NOPARAM_DEFAULT)(PARAM_DEFAULT("0"))(PARAM_DEFAULT(0))(PARAM_DEFAULT(0.5))(PARAM_DEFAULT(0))
+#define paramreferences (forcesfile)(deltat)(steps)(DoOutput)(MaxDistance)(DampingFactor)(UseBondGraph)
 #define paramvalids \
 (DummyValidator< boost::filesystem::path >()) \
+(RangeValidator< double >(std::numeric_limits<double>::min(), std::numeric_limits<double>::max())) \
 (NotZeroValidator< unsigned int >()) \
 (DummyValidator<bool>()) \
Index: src/Dynamics/ForceAnnealing.hpp
===================================================================
--- src/Dynamics/ForceAnnealing.hpp	(revision b2acca5104402761508b07b19e72cf9e4706bced)
+++ src/Dynamics/ForceAnnealing.hpp	(revision 21684049418b92d984cca9a3de2814706b588f5f)
@@ -60,13 +60,15 @@
   ForceAnnealing(
       AtomSetMixin<T> &_atoms,
+      const double _Deltat,
       bool _IsAngstroem,
       const size_t _maxSteps,
       const int _max_distance,
       const double _damping_factor) :
-    AtomicForceManipulator<T>(_atoms, 1., _IsAngstroem),
+    AtomicForceManipulator<T>(_atoms, _Deltat, _IsAngstroem),
     maxSteps(_maxSteps),
     max_distance(_max_distance),
     damping_factor(_damping_factor)
   {}
+
   /** Destructor of class ForceAnnealing.
    *
@@ -110,5 +112,4 @@
         anneal(_CurrentTimeStep, _offset, maxComponents);
     }
-
 
     LOG(1, "STATUS: Largest remaining force components at step #"